SystemOrganization addCategory: #'Phidget-VMMaker-Plugins'!

SmartSyntaxInterpreterPlugin subclass: #PhidgetPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-VMMaker-Plugins'!

!PhidgetPlugin commentStamp: 'pt 5/3/2009 13:55' prior: 0!
A PhidgetPlugin is a plugin to enable the use of Phidgets (For more information about Phidgets see www.phidgets.com).

Instance Variables: - none -
!

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/6/2009 17:20'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:58'!
requiresCrossPlatformFiles
	"default is ok for most, any plugin needing platform specific files must say so"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:57'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^true! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'lk 6/14/2009 18:14'!
initialiseModule
	"Initialise the module"

	self export: true.
	self cCode: 'phidgetPlugin_Initialise()'.
	^ 1! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 11:46'!
phidgetIdOf: byteArray
	"Return the PhidgetId of the given Smalltalk bytes object, or nil if oop is not a PhidgetId."

	self returnTypeC: 'PhidgetId* '.
	interpreterProxy success:
		( ( interpreterProxy isIntegerObject: byteArray ) not and:
		 [ ( interpreterProxy isBytes: byteArray ) and:
		 [ ( interpreterProxy slotSizeOf: byteArray ) = ( self cCode: 'sizeof(PhidgetId)' ) ] ] ).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(PhidgetId*)(byteArray + 4)'! !

!PhidgetPlugin methodsFor: 'Phidget: Accelerometer' stamp: 'sp 6/18/2009 17:12'!
primAccelerometerCreate

	self primitive: 'primAccelerometerCreate' parameters: #().
	^ self cCode: 'phidgetAccel_Create()'! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 14:29'!
primClose: phidgetIdArray

	| phidgetId |
	self primitive: 'primClose' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_Close(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Analog Sensor' stamp: 'lk 6/15/2009 15:56'!
primGetAnalogSensorValue: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAnalogSensorValue' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAnalogSensor_GetValue(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/18/2009 22:04'!
primGetAxisAcceleration: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAxisAcceleration' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAxis_GetAcceleration(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/18/2009 22:05'!
primGetAxisAccelerationMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAxisAccelerationMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAxis_GetAccelerationMax(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/18/2009 22:05'!
primGetAxisAccelerationMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAxisAccelerationMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAxis_GetAccelerationMin(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Input' stamp: 'lk 6/15/2009 15:57'!
primGetDigitalInputValue: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetDigitalInputValue' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalInput_GetValue(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'lk 6/15/2009 15:57'!
primGetDigitalOutputValue: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetDigitalOutputValue' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalOutput_GetValue(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'sp 6/18/2009 17:02'!
primGetDoubleSensitivity: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetIndexedDoubleSensitivity' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetComponent_GetIndexedDoubleSensitivity(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'sp 6/18/2009 17:01'!
primGetIntegerSensitivity: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetIndexedIntegerSensitivity' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetComponent_GetIndexedIntegerSensitivity(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 20:25'!
primGetLastRFIDTag: phidgetIdArray

	| phidgetId tagArrayOop tagArray |
	self primitive: 'primGetLastRFIDTag' parameters: #(Oop).
	self var: #tagArray type: 'char *'.
	self var: #phidgetId type: 'PhidgetId'.
	
	tagArrayOop := interpreterProxy
		instantiateClass: interpreterProxy classByteArray
		indexableSize: 5.
	tagArray := self cCode: '(char *) (tagArrayOop + 4)'.
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetCompRFID_GetLastTag(phidgetId, tagArray)' ].
	^ tagArrayOop! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:26'!
primGetServoPosition: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetServoPosition' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompServoMotor_GetPosition(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 23:13'!
primGetServoPositionMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetServoPositionMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompServoMotor_GetPositionMax(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/16/2009 11:54'!
primGetServoPositionMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetServoPositionMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompServoMotor_GetPositionMin(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 20:26'!
primHasRFIDTag: phidgetIdArray

	| phidgetId |
	self primitive: 'primHasRFIDTag' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_HasTag(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget: Interface Kit' stamp: 'lk 6/15/2009 17:14'!
primInterfaceKitCreate

	self primitive: 'primInterfaceKitCreate' parameters: #().
	^ self cCode: 'phidgetIfKit_Create()'! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 13:01'!
primIsAttached: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsAttached' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_isAttached(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 20:26'!
primIsRFIDAntennaOn: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsRFIDAntennaOn' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_IsAntennaOn(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:27'!
primIsServoEngaged: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primIsServoEngaged' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_IsEngaged(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Simple LED' stamp: 'lk 6/15/2009 20:38'!
primIsSimpleLEDOn: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsSimpleLEDOn' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompSimpleLED_IsOn(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 13:01'!
primIsValid: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsValid' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_isValid(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'lk 6/14/2009 21:00'!
primLastError

	self primitive: 'primLastError' parameters: #( ).
	
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidget_LastError()' )! !

!PhidgetPlugin methodsFor: 'Component: Analog Sensor' stamp: 'lk 6/15/2009 15:56'!
primNumAnalogSensors: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumAnalogSensors' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAnalogSensor_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/18/2009 17:04'!
primNumAxes: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumAxes' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAxis_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Input' stamp: 'lk 6/15/2009 15:57'!
primNumDigitalInputs: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumDigitalInputs' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalInput_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'lk 6/15/2009 15:57'!
primNumDigitalOutputs: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumDigitalOutputs' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalOutput_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:21'!
primNumServoMotors: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumServoMotors' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 13:58'!
primOpen: phidgetIdArray withSerial: serial

	| phidgetId |
	self primitive: 'primOpen' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_Open(phidgetId, serial)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget: RFID' stamp: 'lk 6/15/2009 21:04'!
primRFIDCreate

	self primitive: 'primRFIDCreate' parameters: #().
	^ self cCode: 'phidgetRFID_Create()'! !

!PhidgetPlugin methodsFor: 'Phidget: Servo' stamp: 'lk 6/15/2009 22:19'!
primServoCreate

	self primitive: 'primServoCreate' parameters: #().
	^ self cCode: 'phidgetServo_Create()'! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'lk 6/15/2009 15:57'!
primSetDigitalOutputValue: phidgetIdArray at: index to: value

	| phidgetId |
	self primitive: 'primSetDigitalOutputValue' parameters: #(Oop SmallInteger SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalOutput_SetValue(phidgetId, index, value)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'sp 6/18/2009 21:03'!
primSetDoubleSensitivity: phidgetIdArray at: index to: value

	|floatSensitivity phidgetId|
	self primitive: 'primSetIndexedDoubleSensitivity' parameters: #(Oop SmallInteger Oop ).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatSensitivity type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatSensitivity := interpreterProxy floatValueOf: value.
	
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetComponent_SetIndexedDoubleSensitivity(phidgetId, index, floatSensitivity)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'sp 6/18/2009 16:58'!
primSetIntegerSensitivity: phidgetIdArray at: index to: value

	| phidgetId |
	self primitive: 'primSetIndexedIntegerSensitivity' parameters: #(Oop SmallInteger SmallInteger ).
	self var: #phidgetId type: 'PhidgetId'.

	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetComponent_SetIndexedIntegerSensitivity(phidgetId, index, value)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 20:26'!
primSetRFIDAntennaState: phidgetIdArray to: anInteger

	| phidgetId |
	self primitive: 'primSetRFIDAntennaState' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_SetAntennaState(phidgetId, anInteger)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Analog Sensor' stamp: 'lk 6/15/2009 15:58'!
primSetSemaphoreIndexAnalogSensorChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAnalogSensorChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAnalogSensor_SetSemaphoreIndex_Change(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 12:45'!
primSetSemaphoreIndexAttach: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAttach' parameters: #(SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidget_SetSemaphoreIndex_Attach(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/18/2009 17:07'!
primSetSemaphoreIndexAxisChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAxisChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAxis_SetSemaphoreIndex_Change(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 12:45'!
primSetSemaphoreIndexDetach: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexDetach' parameters: #(SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidget_SetSemaphoreIndex_Detach(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Input' stamp: 'lk 6/15/2009 15:58'!
primSetSemaphoreIndexDigitalInputChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexDigitalInputChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalInput_SetSemaphoreIndex_Change(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'lk 6/15/2009 15:59'!
primSetSemaphoreIndexDigitalOutputChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexDigitalOutputChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalOutput_SetSemaphoreIndex_Change(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 12:45'!
primSetSemaphoreIndexError: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexError' parameters: #(SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidget_SetSemaphoreIndex_Error(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 17:46'!
primSetSemaphoreIndexRFIDTagFound: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexRFIDTagFound' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_SetSemaphoreIndex_TagFound(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 17:46'!
primSetSemaphoreIndexRFIDTagLost: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexRFIDTagLost' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_SetSemaphoreIndex_TagLost(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:33'!
primSetSemaphoreIndexServoPositionChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexServoPositionChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_SetSemaphoreIndex_PositionChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/16/2009 12:02'!
primSetServoEngaged: phidgetIdArray at: index to: state

	| phidgetId |
	self primitive: 'primSetServoEngaged' parameters: #(Oop SmallInteger SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_SetEngaged(phidgetId, index, state)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:34'!
primSetServoPosition: phidgetIdArray at: index to: position

	| phidgetId floatPosition |
	self primitive: 'primSetServoPosition' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatPosition := interpreterProxy floatValueOf: position.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_SetPosition(phidgetId, index, floatPosition)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Simple LED' stamp: 'lk 6/15/2009 20:38'!
primSetSimpleLEDState: phidgetIdArray to: state

	| phidgetId |
	self primitive: 'primSetSimpleLEDState' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompSimpleLED_SetState(phidgetId, state)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'lk 6/14/2009 18:14'!
shutdownModule
	"Shutdown the module"
	
	self export: true.
	self cCode: 'phidgetPlugin_Shutdown()'.
	^ 1! !
